import numpy as np
import pandas as pd
from navipy.database import DataBaseLoad
from navipy.processing.pcode import apcv, skyline
from navipy import Brain
import pkg_resources

# 0) Define a class heriting from Brain


class ASVBrain(Brain):
    def __init__(self, renderer=None,
                 channel=0, goalpos=[0, 0]):
        Brain.__init__(self, renderer=renderer)
        # Init memory
        locid = self.posorients[(mydb.posorients.x == goalpos[0])
                                & (mydb.posorients.y == goalpos[1])].index[0]
        posorient = mydb.posorients.loc[locid, :]
        self.update(posorient)
        self.channel = channel
        self.memory = self.asv()

    def asv(self):
        skyl = skyline(self.vision.scene)
        vector = apcv(skyl,
                      self.vision.viewing_directions)
        return vector[..., self.channel, :]

    def velocity(self):
        homing_vector = self.memory - self.asv()
        homing_vector = np.squeeze(homing_vector)
        velocity = pd.Series(data=0,
                             index=['dx', 'dy', 'dz',
                                    'dalpha_0', 'dalpha_1', 'dalpha_2'])
        velocity[['dx', 'dy', 'dz']] = homing_vector
        return velocity


# 1) Connect to the database
mydb_filename = pkg_resources.resource_filename(
    'navipy', 'resources/database.db')
mydb = DataBaseLoad(mydb_filename)
mybrain = ASVBrain(renderer=mydb)
# 2) Define the position-orinetation at which
# we want the image
posorient = mydb.posorients.loc[12, :]
mybrain.update(posorient)
mybrain.velocity()
