import matplotlib.pyplot as plt
from navipy.database import DataBaseLoad
import navipy.processing as processing
from navipy import Brain
import pkg_resources


# 1) Connect to the database
mydb_filename = pkg_resources.resource_filename(
    'navipy', 'resources/database.db')
mydb = DataBaseLoad(mydb_filename)
mybrain = Brain(renderer=mydb)
# 2) Define the position-orinetation at which
# we want the image
posorient = mydb.posorients.loc[12, :]
mybrain.update(posorient)
my_contrast = processing.pcode.contrast_weighted_nearness(
    mybrain.vision.scene)

f, axarr = plt.subplots(2, 2, figsize=(15, 8))
axarr = axarr.flatten()
for chan_i, chan_n in enumerate(mydb.channels):
    ax = axarr[chan_i]
    ax.imshow(my_contrast[:, :, chan_i, 0])
    ax.set_title('channel: ' + chan_n)
    ax.invert_yaxis()

f.show()
