import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from navipy.database import DataBaseLoad
import pkg_resources


# 1) Connect to the database
mydb_filename = pkg_resources.resource_filename(
    'navipy', 'resources/database.db')
mydb = DataBaseLoad(mydb_filename)
# 2) Define the position-orinetation at which
# we want the image
posorient = pd.Series(index=['x', 'y', 'z',
                             'alpha_0', 'alpha_1', 'alpha_2'])
posorient.x = 0.0
posorient.y = -0.25
posorient.z = 3.0
posorient.alpha_0 = np.pi / 2
posorient.alpha_1 = 0
posorient.alpha_2 = 0
# 3) Load the image
image = mydb.scene(posorient=posorient)
image = image[..., 0]
# 4) plot the image
to_plot_im = image[:, :, :3]
to_plot_im -= to_plot_im.min()
to_plot_im /= to_plot_im.max()
to_plot_im = to_plot_im * 255
to_plot_im = to_plot_im.astype(np.uint8)
to_plot_dist = image[:, :, 3]

plt.subplot(1, 2, 1)
plt.imshow(to_plot_im)
plt.gca().invert_yaxis()

plt.subplot(1, 2, 2)
plt.imshow(to_plot_dist)
plt.gca().invert_yaxis()

plt.show()
