import pandas as pd
from navipy.database import DataBaseLoad
from navipy import Brain
import pkg_resources

# 0) Define a class heriting from Brain


class StaticBrain(Brain):
    def __init__(self, renderer=None):
        Brain.__init__(self, renderer=renderer)

    def velocity(self):
        velocity = pd.Series(data=0,
                             index=['dx', 'dy', 'dz',
                                    'dalpha_0', 'dalpha_1', 'dalpha_2'])
        return velocity


# 1) Connect to the database
mydb_filename = pkg_resources.resource_filename(
    'navipy', 'resources/database.db')
mydb = DataBaseLoad(mydb_filename)
mybrain = StaticBrain(renderer=mydb)
# 2) Define the position-orinetation at which
# we want the image
posorient = mydb.posorients.loc[12, :]
mybrain.update(posorient)
mybrain.velocity()
